;ADD    BX,AX   00000011  11 011 000
;                     dw mod reg r/m
;  /m  (/)        mod  
;                 ,    .25.2.
;                __________________________________________________________________________
;
;    r/m   mod=00    mod=01         mod=10      mod=11    mod=11
;                                               w=0        w=1
;   000   BX+SI     BX+SI+disp     BX+SI+disp    AL         AX
;   001   BX+DI     BX+DI+disp     BX+DI+disp    CL         CX
;   010   BP+SI     BP+SI+disp     BP+SI+disp    DL         DX
;   011   BP+DI     BP+DI+disp     BP+DI+disp    BL         BX
;   100    SI        SI+disp         SI+disp     AH         SP
;   101    DI        DI+disp         DI+disp     CH         BP
;   110   Direct     BP+disp         BP+disp     DH         SI
;   111    BX        BX+disp         BX+disp     BH         DI
;               _____________________________________________________
;            word                       byte
;add          03       11  reg r/m       02       11  reg r/m
;or           0b       11  reg r/m       0a       11  reg r/m
;adc          13       11  reg r/m       12       11  reg r/m
;sbb          1b       11  reg r/m       18       11  reg r/m
;and          23       11  reg r/m       22       11  reg r/m
;sub          2b       11  reg r/m       28       11  reg r/m
;xor          33       11  reg r/m       32       11  reg r/m
;cmp          3b       11  reg r/m       3a       11  reg r/m
;test         85       11  reg r/m       84       11  reg r/m
;xchg         87       11  reg r/m       86       11  reg r/m
;mov          8b       11  reg r/m       8a       11  reg r/m
;not          f7       11  010 r/m       f6       11  010 r/m
;mul          f7       11  100 r/m       f6       11  100 r/m
;div          f7       11  110 r/m       f6       11  110 r/m
;inc          FF       11  000 r/m       FE       11  000 r/m
;dec          FF       11  001 r/m       FE       11  001 r/m

;define       AL     0
;define       CL     1
;define       DL     2
;define       BL     3
;define       AH     4
;define       CH     5
;define       DH     6
;define       BH     7

;define      AX      0
;define      CX      1
;define      DX      2
;define      BX      3
;define      SP      4
;define      BP      5
;define      SI      6
;define      DI      7

;define       al     0
;define       cl     1
;define       dl     2
;define       bl     3
;define       ah     4
;define       ch     5
;define       dh     6
;define       bh     7

;define      ax     0
;define      cx      1
;define      dx     2
;define      bx     3
;define      sp     4
;define      bp      5
;define      si      6
;define      di      7























;loop         e2
;jg           7f
;jng ;jle     7e
;jnl          7d
;jl           7c
;jnp          7b
;jp           7a
;jns          79
;js           78
;ja           77
;jna ;jbe     76
;jnz ;jne     75
;jz  ;je      74
;jnc          73
;jc  ;jb      72
;jno          71
;Jo           70
;jmp          eb
;call         e8
;ret          c3

macro ext instr
{
macro instr op1,op2
\{
if op1 in <ax,bx,cx,dx,sp,bp,si,di> & op2 in <ax,bx,cx,dx,sp,bp,si,di>

if instr in <add >
db 0x03
end if
if instr in <or >
db 0x0b
end if
if instr in <adc >
db 0x13
end if
if instr in <sbb >
db 0x1b
end if
if instr in <and >
db 0x23
end if
if instr in <sub >
db 0x2b
end if
if instr in <xor >
db 0x33
end if
if instr in <cmp >
db 0x3b
end if

if instr in <test >
db 0x85
end if
if instr in <xchg>
db 0x87
end if
if instr in <mov >
db 0x8b
end if
if instr in <esc >
db 0xd9
end if


;operand ;;;;;;;;;;;;;;;;;;;;;
;db (0xc0 + op1 +8*op2)

if op1	in <ax> & op2 in <ax>
db 0xc0
end if
if op1	in <ax> & op2 in <cx>
db 0xc1
end if
if op1	in <ax> & op2 in <dx>
db 0xc2
end if
if op1	in <ax> & op2 in <bx>
db 0xc3
end if
if op1	in <ax> & op2 in <sp>
db 0xc4
end if
if op1	in <ax> & op2 in <bp>
db 0xc5
end if
if op1	in <ax> & op2 in <si>
db 0xc6
end if
if op1	in <ax> & op2 in <di>
db 0xc7
 end if


if op1	in <cx> & op2 in <ax>
db 0xc8
end if
if op1	in <cx> & op2 in <cx>
db 0xc9
end if
if op1	in <cx> & op2 in <dx>
db 0xca
end if
if op1	in <cx> & op2 in <bx>
db 0xcb
end if
if op1	in <cx> & op2 in <sp>
db 0xcc
end if
if op1	in <cx> & op2 in <bp>
db 0xcd
end if
if op1	in <cx> & op2 in <si>
db 0xce
end if
if op1	in <cx> & op2 in <di>
db 0xcf
end if

if op1	in <dx> & op2 in <ax>
db 0xd0
end if
if op1	in <dx> & op2 in <cx>
db 0xd1
end if
if op1	in <dx> & op2 in <dx>
db 0xd2
end if
if op1	in <dx> & op2 in <bx>
db 0xd3
end if
if op1	in <dx> & op2 in <sp>
db 0xd4
end if
if op1	in <dx> & op2 in <bp>
db 0xd5
end if
if op1	in <dx> & op2 in <si>
db 0xd6
end if
if op1	in <dx> & op2 in <di>
db 0xd7
 end if

if op1	in <bx> & op2 in <ax>
db 0xd8
end if
if op1	in <bx> & op2 in <cx>
db 0xd9
end if
if op1	in <bx> & op2 in <dx>
db 0xda
end if
if op1	in <bx> & op2 in <bx>
db 0xdb
end if
if op1	in <bx> & op2 in <sp>
db 0xdc
end if
if op1	in <bx> & op2 in <bp>
db 0xdd
end if
if op1	in <bx> & op2 in <si>
db 0xde
end if
if op1	in <bx> & op2 in <di>
db 0xdf
end if


if op1	in <sp> & op2 in  <ax>
db 0xe0
end if
if op1	in <sp> & op2 in  <cx>
db 0xe1
end if
if op1	in <sp> & op2 in  <dx>
db 0xe2
end if
if op1	in <sp> & op2 in  <bx>
db 0xe3
end if
if op1	in <sp> & op2 in  <sp>
db 0xe4
end if
if op1	in <sp> & op2 in  <bp>
db 0xe5
end if
if op1	in <sp> & op2 in  <si>
db 0xe6
end if
if op1	in <sp> & op2 in  <di>
db 0xe7
 end if


if op1	in <bp> & op2 in   <ax>
db 0xe8
end if
if op1	in <bp> & op2 in   <cx>
db 0xe9
end if
if op1	in <bp> & op2 in   <dx>
db 0xea
end if
if op1	in <bp> & op2 in   <bx>
db 0xeb
end if
if op1	in <bp> & op2 in   <sp>
db 0xec
end if
if op1	in <bp> & op2 in   <bp>
db 0xed
end if
if op1	in <bp> & op2 in   <si>
db 0xee
end if
if op1	in <bp> & op2 in   <di>
db 0xef
end if

if op1	in <si> & op2 in <ax>
db 0xf0
end if
if op1	in <si> & op2 in <cx>
db 0xf1
end if
if op1	in <si> & op2 in <dx>
db 0xf2
end if
if op1	in <si> & op2 in <bx>
db 0xf3
end if
if op1	in <si> & op2 in <sp>
db 0xf4
end if
if op1	in <si> & op2 in <bp>
db 0xf5
end if
if op1	in <si> & op2 in <si>
db 0xf6
end if
if op1	in <si> & op2 in <di>
db 0xf7
 end if

if op1	in <di> & op2 in <ax>
db 0xf8
end if
if op1	in <di> & op2 in <cx>
db 0xf9
end if
if op1	in <di> & op2 in <dx>
db 0xfa
end if
if op1	in <di> & op2 in <bx>
db 0xfb
end if
if op1	in <di> & op2 in <sp>
db 0xfc
end if
if op1	in <di> & op2 in <bp>
db 0xfd
end if
if op1	in <di> & op2 in <si>
db 0xfe
end if
if op1	in <di> & op2 in <di>
db 0xff
end if

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
else

if op1 in  <al,bl,cl,dl,ah,bh,ch,dh> & op2 in <al,bl,cl,dl,ah,bh,ch,dh>

if instr in <add >
db 0x02
end if
if instr in <or >
db 0x0a
end if
if instr in <adc >
db 0x12
end if
if instr in <sbb >
db 0x1a
end if
if instr in <and >
db 0x22
end if
if instr in <sub >
db 0x2a
end if
if instr in <xor >
db 0x32
end if
if instr in <cmp >
db 0x3a
end if

if instr in <test >
db 0x84
end if
if instr in <xchg>
db 0x86
end if
if instr in <mov >
db 0x8a
end if



;operand ;;;;;;;;;;;;;;;;;;;;;
;db (0xc0 + op1 +8*op2)

if op1	in <al> & op2 in  <al>
db 0xc0
end if
if op1	in <al> & op2 in  <cl>
db 0xc1
end if
if op1	in <al> & op2 in  <dl>
db 0xc2
end if
if op1	in <al> & op2 in  <bl>
db 0xc3
end if
if op1	in <al> & op2 in  <ah>
db 0xc4
end if
if op1	in <al> & op2 in  <ch>
db 0xc5
end if
if op1	in <al> & op2 in  <dh>
db 0xc6
end if
if op1	in <al> & op2 in  <bh>
db 0xc7
 end if

if op1	in <cl> & op2 in  <al>
db 0xc8
end if
if op1	in <cl> & op2 in  <cl>
db 0xc9
end if
if op1	in <cl> & op2 in  <dl>
db 0xca
end if
if op1	in <cl> & op2 in  <bl>
db 0xcb
end if
if op1	in <cl> & op2 in  <ah>
db 0xcc
end if
if op1	in <cl> & op2 in  <ch>
db 0xcd
end if
if op1	in <cl> & op2 in  <dh>
db 0xce
end if
if op1	in <cl> & op2 in  <bh>
db 0xcf
 end if

if op1	in <dl> & op2 in  <al>
db 0xd0
end if
if op1	in <dl> & op2 in  <cl>
db 0xd1
end if
if op1	in <dl> & op2 in  <dl>
db 0xd2
end if
if op1	in <dl> & op2 in  <bl>
db 0xd3
end if
if op1	in <dl> & op2 in  <ah>
db 0xd4
end if
if op1	in <dl> & op2 in  <ch>
db 0xd5
end if
if op1	in <dl> & op2 in  <dh>
db 0xd6
end if
if op1	in <dl> & op2 in  <bh>
db 0xd7
 end if

if op1	in <bl> & op2 in   <al>
db 0xd8
end if
if op1	in <bl> & op2 in   <cl>
db 0xd9
end if
if op1	in <bl> & op2 in   <dl>
db 0xda
end if
if op1	in <bl> & op2 in   <bl>
db 0xdb
end if
if op1	in <bl> & op2 in   <ah>
db 0xdc
end if
if op1	in <bl> & op2 in   <ch>
db 0xdd
end if
if op1	in <bl> & op2 in   <dh>
db 0xde
end if
if op1	in <bl> & op2 in   <bh>
db 0xdf
 end if

if op1	in <ah> & op2 in  <al>
db 0xe0
end if
if op1	in <ah> & op2 in  <cl>
db 0xe1
end if
if op1	in <ah> & op2 in  <dl>
db 0xe2
end if
if op1	in <ah> & op2 in  <bl>
db 0xe3
end if
if op1	in <ah> & op2 in  <ah>
db 0xe4
end if
if op1	in <ah> & op2 in  <ch>
db 0xe5
end if
if op1	in <ah> & op2 in  <dh>
db 0xe6
end if
if op1	in <ah> & op2 in  <bh>
db 0xe7
 end if

if op1	in <ch> & op2 in   <al>
db 0xe8
end if
if op1	in <ch> & op2 in   <cl>
db 0xe9
end if
if op1	in <ch> & op2 in   <dl>
db 0xea
end if
if op1	in <ch> & op2 in   <bl>
db 0xeb
end if
if op1	in <ch> & op2 in   <ah>
db 0xec
end if
if op1	in <ch> & op2 in   <ch>
db 0xed
end if
if op1	in <ch> & op2 in   <dh>
db 0xee
end if
if op1	in <ch> & op2 in   <bh>
db 0xef
 end if

if op1	in <dh> & op2 in  <al>
db 0xf0
end if
if op1	in <dh> & op2 in  <cl>
db 0xf1
end if
if op1	in <dh> & op2 in  <dl>
db 0xf2
end if
if op1	in <dh> & op2 in  <bl>
db 0xf3
end if
if op1	in <dh> & op2 in  <ah>
db 0xf4
end if
if op1	in <dh> & op2 in  <ch>
db 0xf5
end if
if op1	in <dh> & op2 in  <dh>
db 0xf6
end if
if op1	in <dh> & op2 in  <bh>
db 0xf7
 end if

if op1	in <bh> & op2 in  <al>
db 0xf8
end if
if op1	in <bh> & op2 in  <cl>
db 0xf9
end if
if op1	in <bh> & op2 in  <dl>
db 0xfa
end if
if op1	in <bh> & op2 in  <bl>
db 0xfb
end if
if op1	in <bh> & op2 in  <ah>
db 0xfc
end if
if op1	in <bh> & op2 in  <ch>
db 0xfd
end if
if op1	in <bh> & op2 in  <dh>
db 0xfe
end if
if op1	in <bh> & op2 in  <bh>
db 0xff
 end if
else
if instr in <and> &  op1 in <ax> & op2 eqtype 0x0000+1
db 0x25
dw op2
else
if instr in <cmp> &  op1 in <ax> & op2 eqtype 0x0000+1
db 0x3d
dw op2
else
;,al,bl,cl,dl,ah,bh,ch,dh
 instr op1,op2
 end if
 end if
 end if
  end if



\}
}
ext  add
ext  sub
ext  add
ext  or
ext  adc
ext  sbb
ext  and
ext  sub
ext  xor
ext  cmp
ext  test
ext  xchg
ext  mov
ext  ESC


;mov al,al














;macro mov op1,op2
;{
;if op1 in <ds,es,fs,gs,ss> & op2 in <cs,ds,es,fs,gs,ss>
;   push op2
;   pop op1
;else
;   mov op1,op2
;end if
;}

;macro mov op1,op2,op3
;{
;   if arg3 eq
;      mov op1,op2
;   else
;      mov op1,op2
;      mov op2,op3
;   end if
;}

