
include 'my.inc'
 define GlukOS	1
;include 'corr.inc'

ORG	100h	; kernel

Start:
		push	cs     ;   boot ᥪ   
		pop	ds     ; 뢮 ப
		mov	Word Ptr cs:firsttask+9,1    ;  ਮ 
		mov	Word Ptr cs:firsttask+11,1   ;  ਮ 

		call	Inittasks	   ; 樠 ਯ஢ 
		call	getvectors	   ; ࠭塞  뢠
		call	setvectors	   ; 塞  뢠

		mov	ax,cs
		mov	ds,ax
		mov	di,dos_CurDir
		mov	ah,1
		int	0FFh
	  ; ਬ, ,   boot'
		mov	cx,00101h
		mov	dx,0164Dh
		call	Ramka

	   ; 뢮 ப
		mov	si,string
		mov	dx,011Ah
		call	print

	    ; 뢮 ப
		mov	si,loading
		mov	dx,0300h
		call	print

	    ; 뢮 ப
		mov	si,string0
		call	writeln

	    ; 뢮 ப
		mov	si,string1
		call	writeln

opros:		mov	si,entr
;  cykl: jmp cykl
		call	write

opr1:		call	input

		mov	di,command
		call	UpperString

		mov	al,[command]	     ;
		or	al,al		     ; ᫨ ப 
		jz	opr1
		call	doCmd
		mov	al,[QuitFLG]
		or	al,al
		jz	opros

    IFDEF GlukOS   ;---  
		jmp	far 0F000h:0FFF0h
   ELSE 	  ;---  
		call	_di		     ; 㡨 뢠
		mov	di,tasks
		mov	cx,8
dosexit2:	cmp	Byte Ptr cs:di,0FFh
		jz	dosexit1
		mov	ax,[di+3]
		mov	es,ax
		mov	ah,49h
		push	di
		push	cx
		int	21h
		pop	cx
		pop	di
dosexit1:	add	di,515
		loop	dosexit2
		call	restorevectors
		int	20h
   ENDIF	  ;--- GlukOS

; 믮  #########################################################
PROC		    doCmd
		mov	di,ctable
dCmd3:		mov	si,command
dCmd0:		mov	al,[si]
		cmp	al,[di]
		jne	dCmd1	      ;   

		or	al,al
		jz	dCmd2	      ;  ,  

		inc	di
		inc	si
		jmp	dCmd0
dCmd1:
		inc	di
		cmp	Byte Ptr di,0
		jne	dCmd1

		inc	di
		inc	di
		inc	di
		cmp	Byte Ptr di,0
		jz	dCmd4
		jmp	dCmd3	      ; ஢塞 ᫥ 
dCmd2:
		inc	di
		cmp	Byte Ptr di,0x00
		jne	dCmd2
		inc	di
		push	di
		mov	si,null
		call	writeln

		pop	di
		mov	si,[di]
		call	si
		ret
dCmd4:
		mov	si,null
		call	writeln
		mov	si,error1
		call	writeln
		ret

ENDP		doCmd
;  ப  宬 #########################################################
PROC		input
		mov	ax,cs		   ;
		mov	es,ax		   ;
		mov	di,command	 ; 㫨  ப
		mov	cx,128		   ;
		xor	ax,ax		   ;
		rep	stosb		   ;

		mov	di,command
		mov	bh,[cs:mainy]
		mov	bl,[cs:mainx]
		xor	cx,cx
inp1:		push	cx
		xor	ax,ax
		int	16h

		pop	cx
		cmp	al,13		   ; Enter
		jz	ipEnter
		cmp	al,8		   ; BackSpace
		jz	ipBackSpace
		or	al,al
		jz	inp1
		mov	[cs:di],al
		inc	di
		inc	cx
		cmp	cx,126
		jne	inp2
		dec	di
		dec	cx

inp2:		push	di
		mov	Byte Ptr cs:di,0
		mov	[cs:mainy],bh
		mov	[cs:mainx],bl
		mov	si,command
		push	cx
		call	write
		pop	cx
		pop	di
		jmp	inp1
ipEnter:	ret

ipBackSpace:	push	si
		mov	si,command
		cmp	si,di
		pop	si
		jz	inp1
		dec	di
		push	di
		push	bx
		mov	Byte Ptr cs:di,0
		mov	[cs:mainy],bh
		mov	[cs:mainx],bl
		mov	si,command
		call	write
		mov	si,space
		call	write
		mov	[cs:mainy],bh
		mov	[cs:mainx],bl
		mov	si, command
		call	write
		pop	bx
		pop	di
		dec	cx
		jmp	inp1
;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;
ENDP		input


;               END Start

	      include "disk.asm"

		include "memory.asm"
		include "commands.asm"
		include "utils.asm"
		include "mtasks.asm"
		include "lastline.asm"
		include "int_FFh.asm"

;%TITLE          " GlukOS"
;                .286
;                IDEAL
;                MODEL   TINY


db 0
 BytesPerRowa=80*2
rowa=0
LABEL	ScRow Word
REPT	25
DW	(rowa*BytesPerRowa)
rowa=rowa+1
ENDM
db 0

dw 0xA000
dw 0x4000
dw 0xE001
dw 0x8001
dw 0x2002
dw 0xc003
dw 0x6003
dw 0x0004
dw 0xA005
dw 0x4005
dw 0xE006
dw 0x8006
dw 0x2007
dw 0xc008
dw 0x6008
dw 0x0009
dw 0xA00a
dw 0x400a
dw 0xe00b
dw 0x800b
dw 0x200c
dw 0xc00d
dw 0x600d
dw 0x000e
db 0x0f


;  ,  
	      ; DATASEG
QuitFLG 	DB 0
color		DB 01Fh
windowx 	DB 03
windowy 	DB 02
windowhx	DB 15h
windowwx	DB 4Ah
mainx		DB 0
mainy		DB 5
mainwidth	DB 80
mainheight	DB 25
space		DB 20h,0
null		DB 0
MemoryTable	DB 8 DUP (0)
plots		DB ".........",0
entr		DB "$ ",0
string0 	DB "GlukOS v.01 (C) 2000 Misha Krivij",0
string1 	DB "Type 'HELP' for help.",0
error1		DB "Syntax error.",0
string		DB "Welcome to GlukOS v.01",0
loading 	DB "System now loading... please wait...",0
plot		DB ".",0
dvoet		DB ":",0
LastLine	DB 72 DUP (0)		   ; ᫥ ப ࠭
LastLineEnd	DB 0
LastLineFlag	DB 0						 ;  LastLine


		;include "data.inc"         ; 稬   㣮 䠩
ctable	       DB "!",0,"......Quit - only for debuging",0
	       DW doQuit
	       DB "HELP",0,"...Show this help screen",0
	       DW doHELP
	       DB "CLS",0,"....Clear screen",0
	       DW doCLS
	       DB "DIR",0,"....Show curent directory",0
	       DW doDir
	       DB "CD",0,".....Change curent directory",0
	       DW doCD
	       DB "CURDIR",0,".Show curent directory",0
	       DW doCDir
	       DB "START",0,"..Start new task: START <TASKNAME>",0
	       DW doStart
	       DB "KILL",0,"...Unload task: KILL <TASKNAME>",0
	       DW doKill
	       DB "STOP",0,"...Stop task",0
	       DW doStop
	       DB "RESTART",0,"Restart task",0
	       DW doReStart
	       DB "PRIOR",0,"..Set task prioritet",0
	       DW doSetPrioritet
	       DB "LIST",0,"...Tasks list",0
	       DW doList
	       DB "RUN",0,"....Run program",0
	       DW doRun
	       DB     0
numtask        DB     ?
tasknum        DB     ?
Root	       DW     2
RootSect       DW     19
dos_CurDir     DB     "A:\",0,255 DUP(?)
tmp_String     DB     255 DUP (?)
;    ⠫ ################################################
dos_FileName   DB     8 DUP (?)
dos_Ext        DB     3 DUP (?)
dos_Attr       DB     ?
dos_Reserved   DB     10 DUP (?)
dos_Time       DW     ?
dos_Date       DW     ?
dos_ClustNo    DW     ?
dos_SizeL      DW     ?
dos_SizeH      DW     ?
;   FindFirst  FindNext #########################################
find_FileName  DB     8 DUP (?)
find_Ext       DB     3 DUP (?)
find_Attr      DB     ?
find_Reserved  DB     10 DUP (?)
find_Time      DW     ?
find_Date      DW     ?
find_ClustNo   DW     ?
find_SizeL     DW     ?
find_SizeH     DW     ?
find_inSect    DW     ? 	       ; 
find_inPos     DW     ? 	       ;   ᥪ
; ਯ  ##########################################################
					; typedef struct ttask {
firsttask      DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
tasks	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task2	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task3	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task4	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task5	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task6	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task7	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }
task8	       DB ?			;  char id; (255 - no task)
	       DD ?			;  void far * pointer;
	       DW 255 DUP(?)		;  unsigned int stack[255]; }

sector		DB 512 DUP (?)		   ;  ⠥ ᥪ
FAT		DB 9*512 DUP (?)	   ;  ⠥ FAT (9 ᥪ஢)
AbsSectNum	DW ?
AbsHeadNum	DW ?
command 	DB 128 DUP (?);  ப
virtual at 0x8000
call   restorevectors
end virtual
